import numpy as np
from collections import deque

class HatLinearSplineInterpolator(object):
	def __init__(self, x, y):
		if(len(x) != len(y)):
			raise ValueError("x and y have to have the same length")

		self._x = x
		self._y = y

	def eval_at_point(self, x):
		if(x < self._x[0]):
			return 0
		if(x > self._x[-1]):
			return 0

		for i, x_test in enumerate(self._x[:-1]):
			if(x_test <= x <= self._x[i + 1]):
				break

		return self._y[i - 1] + (x - self._x[i - 1]) / (self._x[i] - self._x[i - 1]) * (self._y[i] - self._y[i - 1])

	def equals(self, y):
		result = deque()

		for i, y_test in enumerate(self._y):
			if(not i):
				continue
			if((self._y[i - 1] <= y <= y_test)
				or (self._y[i - 1] >= y >= y_test)):
				if(self._y[i - 1] == y_test):
					result.append(self._x[i - 1])
					continue
				result.append(self._x[i - 1] + (y - self._y[i - 1]) / (self._y[i] - self._y[i - 1]) * (self._x[i] - self._x[i - 1]))

		return np.array(result)


